package com.perfectech.cts;

import android.content.Context;
import android.graphics.Color;
import android.view.View;
import android.widget.TextView;

import com.perfectech.cts.objects.DVIR;

import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.List;

/**
 * Created by jnissley on 7/13/15.
 */
public class DVIRReportsTextViewListAdapter extends TextViewListAdapter<DVIR> {
    private Context context;
    private ViewHolder DVIRReportHolder;

    public DVIRReportsTextViewListAdapter(Context context, int viewid, List<DVIR> objects) {
        super(context, viewid, objects);
        this.context = context;
    }

    protected void bindHolder(TextViewListAdapter.ViewHolder holder) {
        // Binding the holder keeps our data up to date.
        // In contrast to createHolder this method is called for all items
        // So, be aware when doing a lot of heavy stuff here.
        // we simply transfer our object's data to the list item representatives
        DVIRReportViewHolder DVIRReportHolder = (DVIRReportViewHolder) holder;
        DVIR DVIRReportItem = (DVIR)DVIRReportHolder.data;
        SimpleDateFormat dateFormat = new SimpleDateFormat("MMM dd, yyyy hh:mm:ss aa");
        Date convertedDate = new Date();
        try {
            convertedDate = dateFormat.parse(DVIRReportItem.DVIRDateTime);
            //Format for the report view.
            SimpleDateFormat viewFormat = new SimpleDateFormat("MM/dd hh:mm aa");
            DVIRReportHolder.DVIRDateTime.setText(viewFormat.format(convertedDate));
        } catch (ParseException e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
            DVIRReportHolder.DVIRDateTime.setText(DVIRReportItem.DVIRDateTime);
        }
        DVIRReportHolder.DVIRStatus.setText(DVIRReportItem.CompletedDVIR);
        DVIRReportHolder.Location.setText(DVIRReportItem.Location);
        DVIRReportHolder.TruckNo.setText(DVIRReportItem.TrailerNo);

        //Hilight a row in green if not complete. Possible NO and Part so just checking if
        //not equal to YES
        String sStatus = DVIRReportHolder.DVIRStatus.getText().toString().toUpperCase();
        if (!DVIRReportItem.CompletedDVIR.toString().toUpperCase().equals("YES")) {
            DVIRReportHolder.DVIRStatus.setBackgroundColor(Color.GREEN);
            DVIRReportHolder.DVIRDateTime.setBackgroundColor(Color.GREEN);
            DVIRReportHolder.Location.setBackgroundColor(Color.GREEN);
            DVIRReportHolder.TruckNo.setBackgroundColor(Color.GREEN);
        } else {
            DVIRReportHolder.DVIRStatus.setBackgroundColor(Color.LTGRAY);
            DVIRReportHolder.DVIRDateTime.setBackgroundColor(Color.LTGRAY);
            DVIRReportHolder.Location.setBackgroundColor(Color.LTGRAY);
            DVIRReportHolder.TruckNo.setBackgroundColor(Color.LTGRAY);
        }
    }

    @Override
    protected TextViewListAdapter.ViewHolder createHolder(View v) {
        // createHolder will be called only as long, as the ListView is not filled
        // entirely. That is, where we gain our performance:
        // We use the relatively costly findViewById() methods and
        // bind the view's reference to the holder objects.

        TextView DVIRStatus = (TextView) v.findViewById(R.id.tvDVIRReportComplete);
        TextView DVIRDateTime = (TextView) v.findViewById(R.id.tvDVIRReportDate);
        TextView Location = (TextView) v.findViewById(R.id.tvDVIRReportLocation);
        TextView TruckNo = (TextView) v.findViewById(R.id.tvDVIRReportTruckNo);

        this.DVIRReportHolder = new DVIRReportViewHolder(DVIRStatus, DVIRDateTime, Location, TruckNo);
        return DVIRReportHolder;
    }

    public class DVIRReportViewHolder extends ViewHolder {

        public DVIRReportViewHolder(TextView DVIRStatus, TextView Date, TextView location, TextView TruckNo) {
            this.DVIRStatus = DVIRStatus;
            this.DVIRDateTime = Date;
            this.Location = location;
            this.TruckNo = TruckNo;

        }

        TextView DVIRStatus;
        TextView DVIRDateTime;
        TextView Location;
        TextView TruckNo;
    }
}
