package com.perfectech.cts;

import java.util.List;

import android.content.Context;
import android.graphics.Typeface;
import android.view.View;
import android.widget.TextView;

import com.perfectech.cts.objects.Messages;

/**
 * Created by jcairns on 5/14/15.
 */
public class MessageListTextViewListAdapter extends TextViewListAdapter<Messages> {
    private Context context;
    private long ownerPartyId;
    public MessageListTextViewListAdapter(Context context, int viewid,
                                          List<Messages> objects) {
        super(context, viewid, objects);
        this.context = context;
    }

    protected void bindHolder(ViewHolder holder) {
        // Binding the holder keeps our data up to date.
        // In contrast to createHolder this method is called for all items
        // So, be aware when doing a lot of heavy stuff here.
        // we simply transfer our object's data to the list item representatives
        MessageViewHolder messagesHolder = (MessageViewHolder) holder;

        Messages message = (Messages)messagesHolder.data;
        if (message.sMsgStatus.equals("New") ) {
            messagesHolder.message.setTypeface(Typeface.defaultFromStyle(Typeface.BOLD));
            messagesHolder.message.setTextSize(16.0f);
            messagesHolder.status.setTypeface(Typeface.defaultFromStyle(Typeface.BOLD));
            messagesHolder.status.setTextSize(16.0f);
            messagesHolder.from.setTypeface(Typeface.defaultFromStyle(Typeface.BOLD));
            messagesHolder.from.setTextSize(16.0f);
            messagesHolder.date.setTypeface(Typeface.defaultFromStyle(Typeface.BOLD));
            messagesHolder.date.setTextSize(16.0f);
        }
        else {
            messagesHolder.message.setTypeface(Typeface.defaultFromStyle(Typeface.NORMAL));
            messagesHolder.message.setTextSize(16.0f);
            messagesHolder.status.setTypeface(Typeface.defaultFromStyle(Typeface.NORMAL));
            messagesHolder.status.setTextSize(16.0f);
            messagesHolder.from.setTypeface(Typeface.defaultFromStyle(Typeface.NORMAL));
            messagesHolder.from.setTextSize(16.0f);
            messagesHolder.date.setTypeface(Typeface.defaultFromStyle(Typeface.NORMAL));
            messagesHolder.date.setTextSize(16.0f);
        }

        messagesHolder.date.setText(message.sMsgDate);
        messagesHolder.message.setText(message.sMessage);
        messagesHolder.status.setText(message.sMsgStatus);
        messagesHolder.from.setText(message.sFromUserFullName);
    }

    @Override
    protected ViewHolder createHolder(View v) {
        // createHolder will be called only as long, as the ListView is not filled
        // entirely. That is, where we gain our performance:
        // We use the relatively costly findViewById() methods and
        // bind the view's reference to the holder objects.
        TextView from = (TextView) v.findViewById(R.id.tvFrom);
        TextView date = (TextView) v.findViewById(R.id.tvDate);
        TextView status = (TextView) v.findViewById(R.id.tvStatus);
        TextView message = (TextView) v.findViewById(R.id.tvMSG);

        ViewHolder commentsHolder = new MessageViewHolder(date,from,status,message);

        return commentsHolder; // return our new holder
    }

}
