package com.perfectech.cts.activities;

import android.content.Context;
import android.content.Intent;
import android.content.SharedPreferences;
import android.support.v7.app.AppCompatActivity;
import android.os.Bundle;
import android.view.KeyEvent;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.widget.EditText;
import android.widget.LinearLayout;
import android.widget.TextView;

import com.perfectech.cts.R;
import com.perfectech.cts.webServices.SyncJson;

import org.json.JSONArray;
import org.json.JSONObject;

public class ForgotPassword extends AppCompatActivity {
    private static final String sDBName = "CTS.db";
    private static final int iVersionVal = 5;
    LinearLayout forgotpw;
    JSONObject oAnswers;
    EditText etAnswer1;
    EditText etAnswer2;
    String sUserID = "";
    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_forgot_password);
        SharedPreferences prefs = getSharedPreferences("CTSSharedPrefs",
                Context.MODE_PRIVATE);
        sUserID = prefs.getString("UserID","No Value");
    }

    @Override
    public boolean onCreateOptionsMenu(Menu menu) {
        // Inflate the menu; this adds items to the action bar if it is present.
        getMenuInflater().inflate(R.menu.menu_forgot_password, menu);
        TextView tvQuestion1 = (TextView) findViewById(R.id.tvchallenge1question);
        TextView tvQuestion2 = (TextView) findViewById(R.id.tvchallenge2question);
        etAnswer1 = (EditText) findViewById(R.id.etchallenge1answer);
        etAnswer2 = (EditText) findViewById(R.id.etchallenge2answer);
        oAnswers = getChallengeInfo();
        try {
            tvQuestion1.setText(oAnswers.getString("challenge_question1"));
            tvQuestion2.setText(oAnswers.getString("challenge_question2"));
        } catch(Exception ex) {

        }
        forgotpw = (LinearLayout) findViewById(R.id.tvforgotpwerror);
        etAnswer1.setOnKeyListener(new View.OnKeyListener() {
            @Override
            public boolean onKey(View v, int keyCode, KeyEvent event) {
                forgotpw.setVisibility(View.GONE);
                return false;
            }
        });
        etAnswer2.setOnKeyListener(new View.OnKeyListener() {
            @Override
            public boolean onKey(View v, int keyCode, KeyEvent event) {
                forgotpw.setVisibility(View.GONE);
                return false;
            }
        });
        return true;
    }

    @Override
    public boolean onOptionsItemSelected(MenuItem item) {
        // Handle action bar item clicks here. The action bar will
        // automatically handle clicks on the Home/Up button, so long
        // as you specify a parent activity in AndroidManifest.xml.
        int id = item.getItemId();

        //noinspection SimplifiableIfStatement
        if (id == R.id.submit_answers) {
            if (testAnswers() == true) {
                Intent i = new Intent(getApplicationContext(), UserProfile.class);
                startActivity(i);
                finish();
            } else {
                forgotpw.setVisibility(View.VISIBLE);
            }
            return true;
        }
        return super.onOptionsItemSelected(item);
    }

    private JSONObject getChallengeInfo() {

        JSONObject oSendData = new JSONObject();
        JSONObject oAnswer = new JSONObject();
        try {
            oSendData.put("user_name", sUserID);
        } catch (Exception ex) {

        }

        SyncJson oChallengeQuestions = new SyncJson();
        oChallengeQuestions.oContext = getApplicationContext();
        oChallengeQuestions.sendString = oSendData.toString();
        oChallengeQuestions.webserviceName = "getChallengeItems.php";
        String sResponse = oChallengeQuestions.SyncData();
        if (!sResponse.toUpperCase().equals("[]")) {
            try {
                JSONArray oAnswerArray = new JSONArray(sResponse);
                oAnswer = oAnswerArray.getJSONObject(0);
            } catch (Exception ex) {
                //To do
            }
        }

        return oAnswer;
    }

    private boolean  testAnswers() {
        boolean bRtnValue = false;
        boolean bTestValue = false;
        try {
            String sAnswer1 = oAnswers.getString("challenge_answer1").toString().toUpperCase();
            if (etAnswer1.getText().toString().toUpperCase().equals(sAnswer1)) {
                bTestValue = true;
            }
            if (bTestValue == true) {
                String sAnswer2 = oAnswers.getString("challenge_answer2").toString().toUpperCase();
                if (etAnswer2.getText().toString().toUpperCase().equals(sAnswer2)) {
                    bRtnValue = true;
                }
            }
        } catch (Exception ex) {

        }
        return bRtnValue;
    }
}
